#include "csapp.h"

static char * const cc_args[] = { "./count_child", NULL };

void handle(int sig) {
  sio_puts("\n");
  _exit(1);
}

int main() {
  pid_t pid, fds[2];

  Pipe(fds);

  pid = Fork();
  if (pid == 0) {
    /* Set process group => this child doesn't get Ctl-C */
    setpgid(0, 0);

    /* Redirect input to draw from the pipe */
    Dup2(fds[0], 0);
    /* Close write end, so that we get an EOF when the
       parent is done */
    Close(fds[1]);

    Execve(cc_args[0], cc_args, environ);
  } else {
    /* Close the read end, since we don't need it */
    Close(fds[0]);

    /* Copy bytes from stdin to the pipe: */
    while (1) {
      int n;
      char buffer[256];

      n = Read(0, buffer, sizeof(buffer));
      if (!n)
	break;
      Write(fds[1], buffer, n);
    }

    /* Got EOF, so send Ctl-C to child: */
    Kill(pid, SIGINT);
    
    Waitpid(pid, NULL, 0);
  }

  return 0;
}
